# The BiomotionLab Toolkit for Unity Experiments (bmlTUX)

## An experimental framework for experiments in Unity

The BioMotionLab Toolkit for Unity Experiments helps you design and run experiments in Unity quickly and iteratively without fussing over coding details. You define your variables and experiment structure, and the toolkit will automatically create a table of trials to run. You can customize what happens before, during, and after a trial, block of trials, or the experiment itself, while not having to worry about the details of setting up and running your experiment. You configure an experimental design, write custom behavior and functionality, and then the toolkit will automatically construct your experiment, create and run all required trials, and outputs the results to a file.

For documentation and installation instructions see [Here](https://biomotionlab.github.io/TUX/).

If you use our work, please cite us.

## Authors

Adam O. Bebko  
Nikolaus F. Troje 

Center for Vision Research  
York University  
Toronto, Ontario, Canada

## Abstract
Advances in virtual reality (VR) technology have made it a valuable new tool for vision and perception researchers since it offers a critical depth cue, active motion parallax. Coding VR experiments from scratch is difficult and time-consuming so researchers rely on software such as Unity game engine to create and edit virtual scenes. However, Unity lacks built-in tools for controlling experiments. Existing third-party add-ins require complicated scripts to define experiments. This can be difficult and requires advanced coding knowledge, especially for multifactorial experimental designs. In this paper, we describe a new free and open-source tool called the BiomotionLab Toolkit for Unity Experiments (bmlTUX) that provides a simple interface for controlling experiments in Unity. In contrast to existing tools, bmlTUX provides a graphical interface to automatically handle combinatorics, counterbalancing, randomization, mixed designs, and blocking of trial order. The toolbox works “out-of-the-box” since simple experiments can be created with almost no coding. Furthermore, multiple design configurations can be swapped with a drag-and-drop interface allowing researchers to test new configurations iteratively while maintaining the ability to easily revert to previous configurations. Despite its simplicity, bmlTUX remains highly flexible and customizable, catering to coding novices and experts alike. 

## Download Paper

In Press, submitted to [i-Perception](https://journals.sagepub.com/home/ipe), available as pre-print on PsyArXiv: https://psyarxiv.com/arvkf/

## Citing

Bebko, A. O., & Troje, N. F. (2020 In Press) bmlTUX: Design and control of experiments in virtual reality. _i-Perception. preprint doi: 10.31234/osf.io/arvkf PsyArXiv: https://psyarxiv.com/arvkf

```
@misc{bebko_troje_2020,
 title={BMLtux: Design and control of experiments in virtual reality and beyond},
 url={psyarxiv.com/arvkf},
 DOI={10.31234/osf.io/arvkf},
 publisher={PsyArXiv},
 author={Bebko, Adam O and Troje, Nikolaus F},
 year={2020},
 month={May}
}
```


